from typing import Any, List

import dream3d.simpl

class AppendImageGeometryZSlice(dream3d.simpl.AbstractFilter):
    CheckResolution: bool
    DestinationAttributeMatrix: dream3d.simpl.DataArrayPath
    InputAttributeMatrix: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class CropImageGeometry(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    CellFeatureAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NewDataContainerName: dream3d.simpl.DataArrayPath
    RenumberFeatures: bool
    SaveAsNewDataContainer: bool
    UpdateOrigin: bool
    XMax: int
    XMin: int
    YMax: int
    YMin: int
    ZMax: int
    ZMin: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ExtractFlaggedFeatures(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FlaggedFeaturesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class NearestPointFuseRegularGrids(dream3d.simpl.AbstractFilter):
    ReferenceCellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    SamplingCellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class RegularGridSampleSurfaceMesh(SampleSurfaceMesh):
    CellAttributeMatrixName: str
    DataContainerName: dream3d.simpl.DataArrayPath
    Dimensions: dream3d.simpl.IntVec3
    FeatureIdsArrayName: str
    LengthUnit: int
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class RegularizeZSpacing(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    InputFile: str
    NewZRes: float
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ResampleImageGeom(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    CellFeatureAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NewDataContainerPath: dream3d.simpl.DataArrayPath
    RenumberFeatures: bool
    SaveAsNewDataContainer: bool
    Spacing: dream3d.simpl.FloatVec3
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ResampleRectGridToImageGeom(dream3d.simpl.AbstractFilter):
    Dimensions: dream3d.simpl.IntVec3
    ImageGeomCellAttributeMatrix: str
    ImageGeometryPath: dream3d.simpl.DataArrayPath
    LengthUnit: int
    RectilinearGridPath: dream3d.simpl.DataArrayPath
    SelectedDataArrayPaths: List[dream3d.simpl.DataArrayPath]
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
    @property
    def RectGridGeometryDesc(self) -> str: ...

class SampleSurfaceMesh(dream3d.simpl.AbstractFilter):
    SurfaceMeshFaceLabelsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class SampleSurfaceMeshSpecifiedPoints(SampleSurfaceMesh):
    InputFilePath: str
    OutputFilePath: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class UncertainRegularGridSampleSurfaceMesh(SampleSurfaceMesh):
    CellAttributeMatrixName: str
    DataContainerName: dream3d.simpl.DataArrayPath
    FeatureIdsArrayName: str
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    Uncertainty: dream3d.simpl.FloatVec3
    XPoints: int
    YPoints: int
    ZPoints: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class WarpRegularGrid(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FourthOrderACoeff: dream3d.simpl.Float4thOrderPolynomial
    FourthOrderBCoeff: dream3d.simpl.Float4thOrderPolynomial
    NewDataContainerName: dream3d.simpl.DataArrayPath
    PolyOrder: int
    SaveAsNewDataContainer: bool
    SecondOrderACoeff: dream3d.simpl.Float2ndOrderPolynomial
    SecondOrderBCoeff: dream3d.simpl.Float2ndOrderPolynomial
    ThirdOrderACoeff: dream3d.simpl.Float3rdOrderPoly
    ThirdOrderBCoeff: dream3d.simpl.Float3rdOrderPoly
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
